############################ Recitation 3 Notes ############################ 

## Tuples - Immutable
tuple_1 = () # creating an empty tuple 
tuple_2 = (1,) # tuple with 1 element in it. Note the additional comma
tuple_3 = ("Friday", "Feb", 21)
print(type(tuple_2))
# operations with tuples
print("addition:", tuple_3 + tuple_2) # you can add tuples with the + 
print("length:", len(tuple_3)) # get size of tuple
print("max:", max((3,4,5))) # get max of tuple, similar for min 
print("element at index 0:", tuple_3[0]) # indexing
# gets a subset of tuple, 0 (inclusive) to 2(exclusive)
print("slicing a tuple:", tuple_3[0:2])
# trying to index outside of tuple
tuple_3[9]
# trying to change the value at index 0, can we do this?
tuple_3[0] = "Monday"
print(tuple_3)
# trying to reassign the variable, can we do this?
tuple_3 = ("Monday", "Feb", 1)
print(tuple_3)
# iterating over elments of a tuple
for elem in tuple_3:
    print(elem)
# different approach, go through the indexes
for i in range(len(tuple_3)):
    print(tuple_3[i])


## Lists - Mutable
list_1 = [] # creating an empty list
list_2 = [1,2,3,4] # list with multiple elements
print(type(list_1))
# lists have the same operations as tuples, (and much more!)
# operations with lists
print("multiplication:", list_2*5) # you can add lists with the + 
print("length:", len(list_2)) # get size of list
print("max:", max(list_2)) # get max of list, similar for min 
print("element at index 0:", list_2[0]) # indexing
# gets a subset of list, 0 (inclusive) to 2(exclusive)
print("slicing a list:", list_2[0:2])
# changing the element at index 0
print("Before: ", list_2)
list_2[0] = 10 
print("After: ", list_2)
# adding element to the end
print("Before: ", list_2)
list_2.append(20) 
print("After: ", list_2)
# adding elements of a list to the end of another list 
list_3 = [7]
print("Before List 2", list_2)
print("Before List 3", list_3)
list_2.extend(list_3) # adds the elements in list_3 at the end of list 2
print("After List 3", list_3)
print("After List 2", list_2)
# removing an element from list 
# Method 1: removing at a specific index
print("Before: ", list_2)
del list_2[0]
print("After: ", list_2)
# Method 2: removing from the end of the list
list_4 = ["start", "middle", "middle", "end"]
print("Before: ", list_4)
list_4.pop()
print("After: ", list_4)
# Method 3: remove a specific element from list
print("Before: ", list_4)
list_4.remove("middle")
print("After: ", list_4)
# iterating over a list: will this terminate? 
L = [5,6,7,8]
for i in range(len(L)): 
    L.append(i)
    print(L)
# iterating over a list: will this terminate? 
L = [5,6,7,8]
for i in L: 
    L.append(i)
    print(L)

## Dictionaries - Mutable
# Create dictionary
d = {} # Create empty dictionary
d = {"name":"Mesi", "course": "6.0001", "day": "Friday"} # dictionary with elements inserted
# operations with dictionaries
print(d["name"]) # get value stored in dictionary
print(d["month"]) # raises error if key is not in dictionary 
# Note that there is no inherent order in these
print(d.keys()) # get all of the keys of the dictionary
print(d.values()) # get all of the values of the dictionary
# Adding elements into a dictionary
print("Before:", d)
d["a"] = 1 # Add entry with key “a” mapping to value 1
d[1] = 3  # Add entry with key 1 mapping to value 3
print("After", d)
# reassigning a value
print("Before:", d)
d["name"] = "Mesert" # Reassign key “name” to map to value "Mesert"
print("After", d)
# remove key, value pair
print("Before:", d)
del d["name"] # Remove entry with key "name"
print("After:", d)
# Iteraring through a dictionary
# go through the keys of d
for key in d:
    print(key)
    print(d[key])
    print(key, "->", d[key])
# go through key, value pairs in d 
for elem in d.items():
    print(elem[0],',', elem[1])
    #print(key, "->", value)


## Data Structures
# Immutable Data Types: cannot change element value after assignment
# string, int, float, bool, tuple are examples of immutable types

## Aliasing (important when working with mutable objects)
# not an issue with immutable objects
a = 1
b = a
a=2
print(a) # 2
print(b) # 1

# notice what happens when we mutate l1?
import copy
l1 = [1,2,[3,4]]
l2 = l1
l1[2][0]=0
print("L2", l2) # [1,2,[0,4]]
print("L1",l1) # [1,2,[0,4]]

# aliasing can lead to unexpected behavior, so we need a way to copy/clone lists safely
import copy
# if no nested lists 
l2 = l1[:] # this will create a shallow copy 
l2 = copy.copy(l1) # this will also create a shallow copy 

# if we we have nested lists we need to create a deep copy
l2 = copy.deepcopy(l1) # deep copy


## Debugging
# Try/Except
def divide_strings():
    s = None
    try:
        int1 = input("Enter a number:")
        int2 = float(input("Enter another number:"))
        assert type(int1) == float, "Type is not valid"
        s = int1/int2
    except ValueError:
        raise ValueError("Values are not convertible to integer.")
    except ZeroDivisionError:
        raise ZeroDivisionError("The second integer is zero. Cannot divide by zero")
    except:
        print( "An unexpected error has occurred.")
        raise Exception("An unexpected error has occurred.")  # re-raise the exception so we can see what is wrong
    else:
        # executed if no exception
        print(s)
    finally: 
        # always executed
        print("At the end, s is", s)
divide_strings()

# assert statements can be used to check asssumptions in code
# format assert conditional
assert 1 in [1,2,3]


## (Review) Functions and Scope
two = 2 # global scope
def add_2(number):
    print("Inside add_2")
    number += 2  # this is the same as number = number + 2 
    #two += 2 # Can we do this, Why or why not? 
    two = 6 # Can we do this, Why or why not? 
    print("\tnumber:", number)
    print("\ttwo:", two)
    return number
add_2(10) # add_2(10, 2)
print("Outside add_2 \n\ttwo:", two)
#four = add_2(two) # This is okay! It doesn’t have to be called number
